import unittest

from ok.logging.Logger import get_logger
from ok.test import init_ok

logger = get_logger(__name__)


class TaskTestCase(unittest.TestCase):
    task_class = None
    task = None
    config = None
    ok_map = {}

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

    @classmethod
    def setUpClass(cls):
        init_ok(cls.config)
        # if cls._ok is None:
        logger.info(f'set up cls start {cls}')
        cls.task = cls.task_class()
        from ok.test import ok
        cls.task.feature_set = ok.feature_set
        cls.task._executor = ok.task_executor

    def set_image(self, image):
        from ok.test import ok
        ok.device_manager.capture_method.set_images([image])
        self.task.next_frame()

    def set_images(self, *images):
        from ok.test import ok
        ok.device_manager.capture_method.set_images(images)
        self.task.next_frame()

    def tearDown(self):
        self.task.reset_scene()
